/*
Copyright 2010-2011 Kevin Gimpel

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
#ifndef _UTIL_H
#define	_UTIL_H

#include <vector>
#include <string>
#include <sstream>

using namespace std;

extern const double neg_inf;
extern const double pos_inf;
extern const float neg_inf_float;
extern const float pos_inf_float;

// Returns the number of times that c occurs in s.
int countChar(const string& s, char c);

vector<string> tokenize(const string& str,const string& delimiters);

void tokenize(const string& str, char delimiter, vector<string>& tokens);

int splitString(const string& input, const string& delimiter, vector<string>& results, bool includeEmpties = false);

double logAdd(const double lx, const double ly);

string itos(int i);

// Returns log(x!), computed in the log-domain.
double logFactorial(int x);

// Note: if overflow is experienced, change the implementation
// to use the log domain or write a new version of this function
// that uses the log domain.
int nchoosek(int n, int k);

#endif	/* _UTIL_H */

